
#include "resource_texture.h"
#include "debug.h"


ResourceTexture::ResourceTexture(const std::string& imageName, GLenum target)
    : NewResource(&ResourceTexture::type)
{
  Resources::StorePointer* ptr = this->acquireResource(imageName + ',' + "TEST");

  if (ptr)
  {
    PRINTF(5)("FOUNT TEXTURE: %s\n", imageName.c_str());
    this->acquireData(static_cast<ResourceTexture::TextureResourcePointer*>(ptr)->ptr());
  }
  else
  {
    PRINTF(5)("NOT FOUNT TEXTURE: %s\n", imageName.c_str());
    std::string fileName = this->NewResource::locateFile(imageName);
    this->Texture::loadImage(fileName, target);
    this->NewResource::addResource(new ResourceTexture::TextureResourcePointer(imageName + ',' + "TEST", Resources::KeepLevel(0), this->Texture::dataPointer()));
  }
}


Resources::Type ResourceTexture::type("Texture");





ResourceTexture::TextureResourcePointer::TextureResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const TextureData::Pointer& data)
    : Resources::StorePointer(loadString, keepLevel) , pointer(data)
{}


